
// const value and gClickmenu_del set.

if(!gClickmenu_del){ var gClickmenu_del = {}; }

gClickmenu_del.debugmode = false;
gClickmenu_del.syncTimeout = 5 * 1000; // 5 sec

gClickmenu_del.id = 'ituki-clickmenu_del@mozilla.addons.proj.jp';
gClickmenu_del.title = 'Right Click Menu\'s Item Deleter';
gClickmenu_del.FIREFOX_ID = "{ec8030f7-c20a-464f-9b0e-13a3a9e97384}";
gClickmenu_del.THUNDERBIRD_ID = "{3550f703-e582-4d05-9a08-453d09bdfdc6}";
gClickmenu_del.SEAMONKEY_ID = "{92650c4d-4b8e-4d2a-b7eb-24ecf4f6b63a}";

gClickmenu_del.delmenu_id_datadir = null;


// end const value and gClickmenu_del set.

gClickmenu_del.init = function(){
  gClickmenu_del.prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);

  if (!gClickmenu_del.delmenu_id_datadir){
    gClickmenu_del.prompts.alert(null,gClickmenu_del.title,'addon dir is not set but init... do not work.');
  }

  gClickmenu_del.delmenu_id_datadir.append("data");

  gClickmenu_del.delmenu_id_list = gClickmenu_del.delmenu_id_datadir.clone();
  gClickmenu_del.delmenu_id_list.append("delmenu-id.txt");

  gClickmenu_del.delmenu_movechk = gClickmenu_del.delmenu_id_datadir.clone();
  gClickmenu_del.delmenu_movechk.append("window-tab-change.txt");

  var appInfo = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);
  if(appInfo.ID == gClickmenu_del.FIREFOX_ID) {
    gClickmenu_del.browser = "Firefox";
  }else if(appInfo.ID == gClickmenu_del.THUNDERBIRD_ID) {
    gClickmenu_del.browser = "Thunderbird";
  }else if(appInfo.ID == gClickmenu_del.SEAMONKEY_ID){
    gClickmenu_del.browser = "SeaMonkey";
  }else{
    gClickmenu_del.browser = "Unknown";
  }
  if (gClickmenu_del.debugmode){
    gClickmenu_del.prompts.alert(null,gClickmenu_del.title,"browser=" + gClickmenu_del.browser
                                 + "\ndelmenu-id file[" + gClickmenu_del.delmenu_id_list.path 
                                 + "]\n , tabchange file[" + gClickmenu_del.delmenu_movechk.path
                                 + "]"
                                 );
  }
}

gClickmenu_del.do = function(){
  var prompts = gClickmenu_del.prompts;
  // sync document and menu
  var s = new Date();
  var thread = Components.classes['@mozilla.org/thread-manager;1'].getService().mainThread;
  while(!document){
    thread.processNextEvent(true);
    if (s.getTime() + gClickmenu_del.syncTimeout < (new Date()).getTime()){
      prompts.alert(null,gClickmenu_del.title,'document object get timeout, do not work.');
      return;
    }
  }
  var contentAreaContextMenu = document.getElementById("contentAreaContextMenu");
  while(!contentAreaContextMenu){
    thread.processNextEvent(true);
    if (s.getTime() + gClickmenu_del.syncTimeout < (new Date()).getTime()){
      prompts.alert(null,gClickmenu_del.title,'menu object get timeout, do not work.');
      return;
    }
    contentAreaContextMenu = document.getElementById("contentAreaContextMenu");
  }
  // setup
  var toolId = null;
  var dropObj = true;
  var sepobj = document.createElement("menuseparator");
  sepobj.id = "toolPopupSeparator";
  if (gClickmenu_del.browser == "Firefox"){
    toolId = 'menu_ToolsPopup';
    dropObj = false;
  }else if(gClickmenu_del.browser == "SeaMonkey"){
    toolId = 'taskPopup';
    dropObj = false;
  }else{
    prompts.alert(null,gClickmenu_del.title,'unknown browser, do not work.');
    return;
  }
  var toolsMenu = document.getElementById(toolId);
  if (!toolsMenu){
    prompts.alert(null,gClickmenu_del.title,'Tools(Menu) Context cannot get, do not work.');
    return;
  }
  // move openwindow
  if (gClickmenu_del.delmenu_movechk.exists()){
    // check move
    // SeaMonkey 2.2 and Firefox 3.6.17 xul id
    var windowid = 'context-openlink';
    var tabid = 'context-openlinkintab';
    var windowobj = document.getElementById(windowid);
    var tabobj = document.getElementById(tabid);
    if (!windowobj || !tabobj){
      if (!windowobj && !tabobj){
        prompts.alert(null,gClickmenu_del.title,'Window Open Menu Context and Tab Open Menu Context cannot get. skip window-open - tabopen switch');
      }else if(!windowobj){
        prompts.alert(null,gClickmenu_del.title,'Window Open Menu Context cannot get. skip window-open - tabopen switch');
      }else{
        prompts.alert(null,gClickmenu_del.title,'Tab Open Menu Context cannot get. skip window-open - tabopen switch');
      }
    }else{
      if (gClickmenu_del.debugmode) prompts.alert(null,gClickmenu_del.title,'tab switch');
      // del window obj
      contentAreaContextMenu.removeChild(windowobj);
      // add window obj
      contentAreaContextMenu.insertBefore(windowobj,tabobj);
    }
  }else{
    if (gClickmenu_del.debugmode) prompts.alert(null,gClickmenu_del.title,'tab NOT switch');
  }
  // delete Menu Item's
  if (gClickmenu_del.delmenu_id_list.exists()){
    if (!gClickmenu_del.delmenu_id_list.isFile()){
      prompts.alert(null,gClickmenu_del.title,'Delete menu-id list datafile is not file. skip - delete menu item');
    }else{
      // read all
      var fstream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
      fstream.init(gClickmenu_del.delmenu_id_list, -1, 0, 0);
      var charset = "UTF-8";
      var replacementChar = Components.interfaces.nsIConverterInputStream.DEFAULT_REPLACEMENT_CHARACTER;
      var is = Components.classes["@mozilla.org/intl/converter-input-stream;1"].createInstance(Components.interfaces.nsIConverterInputStream);
      is.init(fstream, charset, 8192, replacementChar);
      var data = "";
      var numChars = 0;
      do{
        var tmp = {};
        numChars = is.readString(4096, tmp);
        if (numChars > 0) data += tmp.value;
      }while(numChars > 0);
      is.close();
      fstream.close();
      // check and del id
      data = data.replace(/\r\n/g,"\n").replace(/\r/g,"\n");
      var dtmp = data.split("\n");
      if (!dropObj){ toolsMenu.appendChild(sepobj); }
      while(dtmp.length > 0){
        var t = dtmp.shift();
        if (gClickmenu_del.debugmode) prompts.alert(null,gClickmenu_del.title,'menu delete:' + t);
        if (t == "") continue; // no data
        if (t.match(/^[\s]*#/)) continue; // comment
        var t2 = t.split(":",2);
        if (t2[0] != "" && t2[0] != gClickmenu_del.browser) continue; // skip other browser id
        // delete id
        var obj = document.getElementById(t2[1]);
        if (!obj){
          t = t.replace(/[\s\t]/g,"");
          if (gClickmenu_del.debugmode) prompts.alert(null,gClickmenu_del.title,'menu delete(2nd step):' + t);
          t2 = t.split(":",2);
          obj = document.getElementById(t2[1]);
        }
        if (!obj){
          prompts.alert(null,gClickmenu_del.title,'Delete menu-id list id(' + t2[1] + ') is not found. skip - delete menu item');
        }else{
          if (gClickmenu_del.debugmode) prompts.alert(null,gClickmenu_del.title,'menu delete and tools add:' + t2[1]);
          try{
            // del obj
            contentAreaContextMenu.removeChild(obj);
          }catch(e){
            prompts.alert(null,gClickmenu_del.title,'menu delete fail:' + t2[1]);
          }
          try{
            // tool menu add...(if obj is removed only, call or getElementById(objid) is error.)
            obj.acceltext = '';
            obj.accesskey = '';
            obj.label = '';
            // obj.sizetopopup = none;
            if (!dropObj) toolsMenu.appendChild(obj);
          }catch(e){
            prompts.alert(null,gClickmenu_del.title,'menu re-add fail:' + t2[1]);
          }
        }
      }
    }
  }else{
    if (gClickmenu_del.debugmode) prompts.alert(null,gClickmenu_del.title,'NO delete menu item');
  }
}

gClickmenu_del.startup = function(){
  if (typeof(Components.classes["@mozilla.org/extensions/manager;1"]) == 'undefined'){
    // SeaMonkey 2.2
    if (typeof(Components.utils) != 'undefined' && typeof(Components.utils.import) != 'undefined'){
      Components.utils.import("resource://gre/modules/AddonManager.jsm");
      AddonManager.getAddonByID(gClickmenu_del.id,function(addon) {
                                                    // async exec(callback)
                                                    try{
                                                      gClickmenu_del.delmenu_id_datadir
                                                        = addon.getResourceURI("").QueryInterface(Components.interfaces.nsIFileURL).file.clone();
                                                    }catch(e){
                                                      gClickmenu_del.delmenu_id_datadir = null
                                                      gClickmenu_del.prompts.alert(null,gClickmenu_del.title,
                                                                                   'cannot find addon directory(callback)... do not work.');
                                                    }
                                                    // init
                                                    gClickmenu_del.init();
                                                    // run
                                                    gClickmenu_del.do();
                                                  });
    }else{
      gClickmenu_del.prompts.alert(null,gClickmenu_del.title,'cannot find addon directory... do not work.');
    }
  }else{
    // Firefox 3 - sync exec
    gClickmenu_del.delmenu_id_datadir = Components.classes["@mozilla.org/extensions/manager;1"]
                                                  .getService(Components.interfaces.nsIExtensionManager)
                                                  .getInstallLocation(gClickmenu_del.id)
                                                  .getItemLocation(gClickmenu_del.id);
    // init
    gClickmenu_del.init();
    // run
    gClickmenu_del.do();
  }
}

gClickmenu_del.startup();

